#ifndef COMMON_H
#define COMMON_H
#include <inttypes.h>
typedef uint32_t uint;
#define CMEMALLOC ;
#define model_print printf
#define ASSERT(expr) \
	do {                         \
		if (!(expr)) {                                                      \
			fprintf(stderr, "Error: assertion failed in %s at line %d\n", __FILE__, __LINE__); \
			/* print_trace(); // Trace printing may cause dynamic memory allocation */ \
			exit(EXIT_FAILURE);                                               \
		}                                                                   \
	} while (0)

#include "hashset.h"
#include "vector.h"
#include "array.h"


class TimingSingleton;
class Abort;
class Entry;
class Slot;
class ByteBuffer;
class Liveness;
class Commit;
class CommitPart;
class ArbitrationRound;
class KeyValue;
class RejectedMessage;
class PendingTransaction;
class CloudComm;
class IoTString;
class LastMessage;
class LocalComm;
class NewKey;
class SlotBuffer;
class SlotIndexer;
class Table;
class TableStatus;
class TimingSingleton;
class Transaction;
class TransactionPart;
class TransactionStatus;
class Error;
class Exception;
class ServerException;

//Code to write
class SecretKeySpec;
class PBEKeySpec;
class SecretKey;
class Mac;
class SecureRandom;
class Thread;
class DataInputStream;
class URL;
class Random;
class Key;
#endif
